#Compile Exe
#Include "win32api.inc"
#Include "commctrl.inc"
#Include "comdlg32.inc"

%IDC_LISTBOX  = 1001 : %IDC_OPEN = 1002 : %IDC_END = 1003

$Progname = "Hex View - "

Global hDlg As Dword, Char As Byte, Buff_In As String, Buff_Out As String

Sub FillListBox()
  Dim Count1 As Long, Count2 As Long
  ListBox Reset hDlg, %IDC_LISTBOX
    For Count1 = 1 To Len(Buff_In) Step 16
      Buff_Out = ""
      For Count2 = Count1 To Count1 + 15
        Buff_Out = Buff_Out + Hex$(Asc(Buff_In, Count2),2) + $Spc
      Next
      Buff_Out = Buff_Out + $Spc + "-" + $Spc + $Spc
      For Count2 = Count1 To Count1 + 15
        Char = Asc(Buff_In, Count2)
        If Char < &h20 Then Char = &h20
        Buff_Out = Buff_Out + Chr$(Char)
      Next
      Buff_Out = Buff_Out + "  [" + Format$(Count1-1, "000000") + "]"

      ListBox Add hDlg, %IDC_LISTBOX, Buff_Out
    Next
End Sub

CallBack Function CbMain()
  Local fNum As Long
  Static Path As String, FName As String, fStart As Long, fStop As Long
  Static fSize As Long
  Select Case CbMsg
    Case %wm_initdialog
    Case %wm_command
      Select Case CbCtl
        Case %IDC_OPEN
          If Path = "" Then Path = CurDir$
          If OpenFileDialog(hDlg, "Open File", fName, Path, "All files (*.*)|*.*", _
                        "", %ofn_filemustexist) Then
            fNum = FreeFile
            Open fName For Binary As #fNum
            fSize = Lof(fNum)
            Get$ #fNum, Lof(fNum), Buff_In
            Close #fNum
            FillListBox
            Dialog Set Text hDlg, $ProgName & fName & " (" & Format$(fSize) & ")
          End If
        Case %IDC_END
          Dialog End hDlg
      End Select
  End Select
End Function

Function WinMain (ByVal CurInst As Long, ByVal PrvInst As Long, _
       ByVal CmdLine As Asciiz Ptr, ByVal CmdShow As Long) Export As Long

  Dialog Font "Lucida Console", 9
  Dialog New 0, $ProgName,,,350,325, %ws_sysmenu To hDlg

  Control Add ListBox, hDlg, %IDC_LISTBOX,,10,10,330,285,%lbs_usetabstops _
    Or %lbs_notify Or %ws_vscroll Or %lbs_disablenoscroll, %ws_ex_clientedge

  Control Add Button, hDlg, %IDC_END,  "Exit"     ,250,290, 30, 15
  Control Add Button, hDlg, %IDC_OPEN, "Open file",150,290, 50, 15
  Dialog Show Modal hDlg, Call CbMain
End Function
